-- | Haskell Ports Library: main interface to the outside world
--
--  Author : Manuel M. T. Chakravarty
--  Created: 14 May 2001
--
--  Version $Revision: 1.3 $ from $Date: 2003/06/22 15:25:32 $
--
--  Copyright (c) 2001 Manuel M. T. Chakravarty
--
--  This file is free software; you can redistribute it and\/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This file is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--- DESCRIPTION ---------------------------------------------------------------
--
--  This modules defines the API of the Haskelll Ports Library.
--
--- DOCU ----------------------------------------------------------------------
--
--  language: Haskell 98
--
--- TODO ----------------------------------------------------------------------
--

module Control.Concurrent.HPL (

  -- the library signature
  --
  version, copyright, disclaimer,

  -- single assignment variables
  --
  module Control.Concurrent.SVars,

  -- thread management
  --
  module Control.Concurrent.ThreadUtils,

  -- ports
  --
  module Control.Concurrent.Ports,

  -- support for managing and interacting with child processes
  --
  module Control.Concurrent.Processes,

  -- new experimental API
  --
  module Control.Concurrent.PortThreads
) where

import Control.Concurrent.PortsVersion (version, copyright, disclaimer)
import Control.Concurrent.SVars
import Control.Concurrent.ThreadUtils
import Control.Concurrent.Ports
import Control.Concurrent.Processes
import Control.Concurrent.PortThreads

